using System;
using System.IO;
using System.Net;
using System.Text;

namespace MedicalInfo
{
  class MainClass
  {
    public static void Main(string[] args)
    {
      string HOST = "localhost";
      string PORT = "8000";
      string USER = "ormaster";
      string PASSWD = "ormaster";
      string CONTENT_TYPE = "application/xml";

      string URL = "http://" + HOST + ":" + PORT + "/api01rv2/system01lstv2";
      /*
         Request_Number :01 診療科対象
                        :02 ドクター対象
                        :03 ドクター以外の職員対象
                        :04 医療機関基本情報

        1.リクエスト番号    Request_Number  (REQUIRED)
        2.基準日            Base_Date       (IMPLIED)

         REQUIRED : 必須   IMPLIED : 任意
      */

      string BODY = @"
      <data>
        <system01_managereq type=""record"">
          <Request_Number type=""string"">04</Request_Number>
          <Base_Date type=""string"">2012-06-01</Base_Date>
        </system01_managereq>
      </data>
      ";

      byte[] BODY_byte = Encoding.UTF8.GetBytes(BODY);
      HttpWebRequest req = (HttpWebRequest) HttpWebRequest.Create(URL);

      req.Method = "POST";
      req.ContentType = CONTENT_TYPE;
      req.ContentLength = BODY_byte.Length;
      req.Credentials = new NetworkCredential(USER, PASSWD);

      Console.WriteLine(BODY);

      HttpWebResponse res = null;
      try
      {
        Stream reqstream = req.GetRequestStream();
        reqstream.Write(BODY_byte, 0, BODY_byte.Length);
        reqstream.Close();

        res = (HttpWebResponse) req.GetResponse();

        Console.WriteLine(res.ResponseUri);
        Console.WriteLine(res.StatusDescription);
      }
      catch(WebException wex)
      {
        if(wex.Status == WebExceptionStatus.ProtocolError)
        {
          HttpWebResponse err = (HttpWebResponse) wex.Response;

          int errcode = (int) err.StatusCode;

          Console.WriteLine(err.ResponseUri);
          Console.WriteLine("{0}:{1}", errcode, err.StatusDescription);

          err.Close();
        }
        else
        {
          Console.WriteLine(wex.Message);
        }
      }
      if(res != null)
      {
        Stream str = res.GetResponseStream();
        StreamReader strread = new StreamReader(str);

        Console.WriteLine(strread.ReadToEnd());

        strread.Close();
        str.Close();
        res.Close();
      }
    }
  }
}


